
fname = getOpenFileName \
caption:"Open Model file" \
types:"msh file (*.msh)|*.msh" \
historyCategory:"PMSH_msh"
f= fopen fname "rb"

fn readschars f num = (
	hstring = "" as stringstream
	for c = 1 to num do (
		bbt = readbyte f #unsigned
		format "%"(bit.intaschar bbt) to:hstring
	)
	hstring as string
)
clearlistener()
hdr = readschars f 9
if hdr != "MESH1999J" then throw ("Unknown file header: "+hdr)
readshort f -- 0x0D0A neboli \n
fseek f 5 #seek_cur
vertexcount = readlong f
facecount = readlong f
layercount = readshort f #unsigned
animcount = readshort f #unsigned
format "Model m % animac (envelopy?)\n" animcount
readbyte f
Vert_array=#()	
uv_array=#()	
Face_array=#()
face_array[facecount]=0
Normal_array=#()
for v1 = 1 to vertexcount do (
	vx = readfloat f
	vy = readfloat f
	vz = readfloat f
	vnx = readfloat f
	vny = readfloat f
	vnz = readfloat f
	u = readfloat f
	v = readfloat f
	tanx = readfloat f
	tany = readfloat f 
	tanz = readfloat f
	bitanx = readfloat f
	bitany = readfloat f
	bitanz = readfloat f
	append uv_array([u,1-v,0] )
	append Normal_array([vnx,-vnz,vny] )
	append Vert_array([vx,-vz,vy] )
)
for x = 1 to facecount do face_array[x] = readshort f #unsigned+1

for bl = 1 to layercount do (
	layer_id = readshort f #unsigned
	lods = readshort f #unsigned
	n3 = readshort f #unsigned
	n4 = readshort f #unsigned
	n5 = readshort f #unsigned
	params = readshort f #unsigned
	for l = 1 to lods do (	
		
		layername = "LOD "+(lods-l) as string
		layerman = LayerManager.getLayerFromName layername
		if layerman == undefined then layerman = LayerManager.newLayerFromName layername
		layerman.current = true
		
		ulod = readfloat f
		mat = readshort f #unsigned
		vcount = readlong f 
		fcount = readlong f 
		for m = 1 to mat do (
			matr = standardmaterial()
			matr.ambient.r = (readfloat f)*255
			matr.ambient.g = (readfloat f)*255
			matr.ambient.b = (readfloat f)*255
			readfloat f --alpha?
			matr.diffuse.r = (readfloat f)*255
			matr.diffuse.g = (readfloat f)*255
			matr.diffuse.b =(readfloat f)*255
			readfloat f
			matr.specular.r = (readfloat f)*255
			matr.specular.g =(readfloat f)*255
			matr.specular.b = (readfloat f)*255		
			readfloat f
			readfloat f
			readfloat f
			readfloat f
			readfloat f
			readfloat f
			readfloat f
			matr.diffusemap = bitmaptexture()
			matr.diffusemap.filename = readschars f 260 
			readschars f 5
			voff = readlong f
			vcnt = readlong f
			foff = readlong f
			fcnt = readlong f
			farr = #()
			foff +=1
			fcnt += foff-2
			voff +=1
			vend = voff+vcnt
			for f = 0 to fcnt do (
				curface = foff + f*3
				if facecount >= curface then (
					f1 = face_array[curface]
					f2 = face_array[curface+1]
					f3 = face_array[curface+2]
					if f1 <= vend and f1 >=voff and f2 <= vend and f2 >=voff and f3 <= vend and f3 >=voff then append farr [f1,f2,f3]
				)
			)
			msh = mesh vertices:Vert_array faces:farr
			for j = 1 to Normal_Array.count do setNormal msh j Normal_Array[j]
			meshop.setNumMaps msh 2
			meshop.setNumMapVerts msh 1 UV_array.count
			for j = 1 to UV_array.count do meshop.setMapVert msh 1 j UV_array[j]
			meshop.buildMapFaces msh 1
			msh.material = matr
			meshop.deleteIsoVerts msh
			msname = "" as stringstream
			format "Layer%_Mat%" bl m to:msname
			msh.name = msname as string
			free farr
		)
		if vcount != 0 and fcount != 0 then ( -- dn normly ani materily, summary mesh pro material fail?
			Vert_array2=#()	
			Face_array2=#()
			UV_array2=#()
			for u1 = 1 to vcount do (
				local pos = [0,0,0]
				pos.x = readfloat f
				pos.z = readfloat f
				pos.y = -readfloat f
				--vdy nula(?)
				readfloat f
				readfloat f

				u = readfloat f
				v = readfloat f
				append Vert_array2 pos
				append uv_array2([u,1-v,0])
			)
			for x = 1 to fcount/3 do (
				fa=readshort f #unsigned+1
				fb=readshort f #unsigned+1
				fc=readshort f #unsigned+1
				append Face_array2[fa,fb,fc]
			)
			msh2 = mesh vertices:Vert_array2 faces:Face_array2	
			meshop.setNumMaps msh2 2
			meshop.setNumMapVerts msh2 1 UV_array2.count
			for j = 1 to UV_array2.count do meshop.setMapVert msh2 1 j UV_array2[j]
			meshop.buildMapFaces msh2 1
			msname = "" as stringstream
			format "Layer%_unkmesh" bl to:msname
			msh2.name = msname as string
			free Vert_array2
			free Face_array2
			free uv_array2
		)
	)
	--edged model, strip model?
	Vert_array3=#()	
	for u1 = 1 to n3 do (
		vx = readfloat f
		vy = readfloat f
		vz = readfloat f
		append Vert_array3 [vx,-vz,vy] 
	)
	Face_array3=#()	
	for x = 1 to n4 do (	--face replacement?
		id=readshort f #unsigned+1
		id2=readshort f #unsigned+1	
	)
	--mesh vertices:Vert_array3 faces:Face_array3
	free Vert_array3
	free face_array3
	for u3 = 1 to n5 do (
		readfloat f
		readfloat f
		readfloat f
		readfloat f
		readshort f
		readbyte f	
	)
	layerman = LayerManager.getLayerFromName "Parameters"
	if layerman == undefined then layerman = LayerManager.newLayerFromName "Parameters"
	layerman.current = true
	layerman.on = false
	for u3 = 1 to params do (
		type = readschars f 101
		for lk= 1 to 15 do readfloat f
		ucnt1 = readlong f
		tpoints=#()
		for u2 = 1 to ucnt1 do (
			_point = [0,0,0]
			_point.x = readfloat f
			_point.z = readfloat f
			_point.y -= readfloat f
			append tpoints _point 
		)
		inneru=1
		if (findString type "boosters") != undefined or (findString type "angle") != undefined then (
			for u2 = 1 to ucnt1/2 do (
				trans = matrixfromnormal (normalize (tpoints[inneru+1] - tpoints[inneru]))
				trans.row4 = tpoints[inneru]	
				point Center_Marker:false Axis_Tripod:true cross:false box:false name: (type+":"+u2 as string) transform: trans
				inneru+=2
			)
		)
		else if (findString type "dock") != undefined or (findString type "breach") != undefined then (
			for u2 = 1 to ucnt1/2 do (
				spl = SplineShape pos:tpoints[inneru] name: (type+":"+u2 as string)
				addNewSpline spl
				addKnot spl 1 #corner #line tpoints[inneru]
				addKnot spl 1 #corner #line tpoints[inneru+1]
				updateShape spl
				inneru+=2			
			)	
		)
		else if (findString type "slot") != undefined then (
			for u2 = 1 to ucnt1/3 while inneru<tpoints.count do (
				zax = normalize (tpoints[inneru+1] - tpoints[inneru])
				xax = normalize (tpoints[inneru+2] - tpoints[inneru])
				trans = matrix3 xax (cross xax zax) zax tpoints[inneru]
				point Center_Marker:false Axis_Tripod:true cross:false box:false name: (type+":"+u2 as string) transform: trans
				inneru+=3
			)
		)
		else if (findString type "blink") != undefined or (findString type "center") != undefined or (findString type "fire") != undefined then 
			for u2 = 1 to ucnt1  do 
				point Center_Marker:false Axis_Tripod:false cross:true box:false name: (type+":"+u2 as string) pos: tpoints[u2]
		
	)
)
-- Uklidme n bordel
free Vert_array
free uv_array
free Face_array
free Normal_array
format "File end of read data: %\n" (ftell f)
fclose f				